'use strict';

exports.__esModule = true;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Loader = require('./Loader');

var _Loader2 = _interopRequireDefault(_Loader);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var BlockUi = function (_Component) {
  (0, _inherits3.default)(BlockUi, _Component);

  function BlockUi() {
    (0, _classCallCheck3.default)(this, BlockUi);
    return (0, _possibleConstructorReturn3.default)(this, _Component.apply(this, arguments));
  }

  BlockUi.prototype.render = function render() {
    var _props = this.props,
        Tag = _props.tag,
        blocking = _props.blocking,
        className = _props.className,
        children = _props.children,
        Loader = _props.loader,
        renderChildren = _props.renderChildren,
        attributes = (0, _objectWithoutProperties3.default)(_props, ['tag', 'blocking', 'className', 'children', 'loader', 'renderChildren']);


    if (blocking) {
      var classes = (0, _classnames2.default)('av-block-ui', className);
      return _react2.default.createElement(
        Tag,
        (0, _extends3.default)({}, attributes, { className: classes }),
        renderChildren && children,
        _react2.default.createElement(
          'div',
          { className: 'av-block-ui-container' },
          _react2.default.createElement('div', { className: 'av-block-ui-overlay' }),
          _react2.default.createElement(
            'div',
            { className: 'av-block-ui-message-container' },
            _react2.default.createElement(
              'div',
              { className: 'av-block-ui-message' },
              _react2.default.isValidElement(Loader) ? Loader : _react2.default.createElement(Loader, null)
            )
          )
        )
      );
    }

    return _react2.default.createElement(
      Tag,
      (0, _extends3.default)({}, attributes, { className: className }),
      children
    );
  };

  return BlockUi;
}(_react.Component);

BlockUi.propTypes = {
  blocking: _react.PropTypes.bool,
  children: _react.PropTypes.node,
  renderChildren: _react.PropTypes.bool,
  className: _react.PropTypes.string,
  loader: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.func, _react.PropTypes.node]),
  tag: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.func])
};
BlockUi.defaultProps = {
  tag: 'div',
  renderChildren: true,
  loader: _Loader2.default
};
exports.default = BlockUi;